/* Generated By:JJTree: Do not edit this line. OCreateSecurityPolicyStatement.java Version 4.3 */
/* JavaCCOptions:MULTI=true,NODE_USES_PARSER=false,VISITOR=true,TRACK_TOKENS=true,NODE_PREFIX=O,NODE_EXTENDS=,NODE_FACTORY=,SUPPORT_CLASS_VISIBILITY_PUBLIC=true */
package com.orientechnologies.orient.core.sql.parser;

import com.orientechnologies.orient.core.command.OCommandContext;
import com.orientechnologies.orient.core.db.ODatabaseInternal;
import com.orientechnologies.orient.core.db.ODatabaseSession;
import com.orientechnologies.orient.core.metadata.security.OSecurityInternal;
import com.orientechnologies.orient.core.metadata.security.OSecurityPolicyImpl;
import com.orientechnologies.orient.core.sql.executor.OInternalResultSet;
import com.orientechnologies.orient.core.sql.executor.OResultInternal;
import com.orientechnologies.orient.core.sql.executor.OResultSet;
import java.util.Map;
import java.util.Objects;

public class OCreateSecurityPolicyStatement extends OSimpleExecStatement {

  protected OIdentifier name;

  protected OBooleanExpression create;
  protected OBooleanExpression read;
  protected OBooleanExpression beforeUpdate;
  protected OBooleanExpression afterUpdate;
  protected OBooleanExpression delete;
  protected OBooleanExpression execute;

  public OCreateSecurityPolicyStatement(int id) {
    super(id);
  }

  public OCreateSecurityPolicyStatement(OrientSql p, int id) {
    super(p, id);
  }

  @Override
  public OResultSet executeSimple(OCommandContext ctx) {
    ODatabaseSession db = (ODatabaseSession) ctx.getDatabase();
    OSecurityInternal security = ((ODatabaseInternal) db).getSharedContext().getSecurity();
    OSecurityPolicyImpl policy = security.createSecurityPolicy(db, name.getStringValue());
    policy.setActive(true);
    if (create != null) {
      policy.setCreateRule(create.toString());
    }
    if (read != null) {
      policy.setReadRule(read.toString());
    }
    if (beforeUpdate != null) {
      policy.setBeforeUpdateRule(beforeUpdate.toString());
    }
    if (afterUpdate != null) {
      policy.setAfterUpdateRule(afterUpdate.toString());
    }
    if (delete != null) {
      policy.setDeleteRule(delete.toString());
    }
    if (execute != null) {
      policy.setExecuteRule(execute.toString());
    }
    security.saveSecurityPolicy(db, policy);

    OResultInternal result = new OResultInternal();
    result.setProperty("operation", "create security policy");
    result.setProperty("name", name.getStringValue());
    OInternalResultSet rs = new OInternalResultSet();
    rs.add(result);
    return rs;
  }

  @Override
  public void toString(Map<Object, Object> params, StringBuilder builder) {
    builder.append("CREATE SECURITY POLICY ");
    name.toString(params, builder);

    boolean first = true;
    if (create != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("CREATE = (");
      create.toString(params, builder);
      builder.append(")");
      first = false;
    }

    if (read != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("READ = (");
      read.toString(params, builder);
      builder.append(")");
      first = false;
    }
    if (beforeUpdate != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("BEFORE UPDATE = (");
      beforeUpdate.toString(params, builder);
      builder.append(")");
      first = false;
    }

    if (afterUpdate != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("AFTER UPDATE = (");
      afterUpdate.toString(params, builder);
      builder.append(")");
      first = false;
    }
    if (delete != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("DELETE = (");
      delete.toString(params, builder);
      builder.append(")");
      first = false;
    }
    if (execute != null) {
      if (first) {
        builder.append(" SET ");
      } else {
        builder.append(", ");
      }
      builder.append("EXECUTE = (");
      execute.toString(params, builder);
      builder.append(")");
      first = false;
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    OCreateSecurityPolicyStatement that = (OCreateSecurityPolicyStatement) o;
    return Objects.equals(name, that.name)
        && Objects.equals(create, that.create)
        && Objects.equals(read, that.read)
        && Objects.equals(beforeUpdate, that.beforeUpdate)
        && Objects.equals(afterUpdate, that.afterUpdate)
        && Objects.equals(delete, that.delete)
        && Objects.equals(execute, that.execute);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, create, read, beforeUpdate, afterUpdate, delete, execute);
  }

  @Override
  public OStatement copy() {
    OCreateSecurityPolicyStatement result = new OCreateSecurityPolicyStatement(-1);
    result.name = name.copy();
    result.create = this.create == null ? null : this.create.copy();
    result.read = this.read == null ? null : this.read.copy();
    result.beforeUpdate = this.beforeUpdate == null ? null : this.beforeUpdate.copy();
    result.afterUpdate = this.afterUpdate == null ? null : this.afterUpdate.copy();
    result.delete = this.delete == null ? null : this.delete.copy();
    result.execute = this.execute == null ? null : this.execute.copy();
    return result;
  }

  @Override
  public boolean executinPlanCanBeCached() {
    if (create != null && !create.isCacheable()) {
      return false;
    }
    if (read != null && !read.isCacheable()) {
      return false;
    }
    if (beforeUpdate != null && !beforeUpdate.isCacheable()) {
      return false;
    }
    if (afterUpdate != null && !afterUpdate.isCacheable()) {
      return false;
    }
    if (delete != null && !delete.isCacheable()) {
      return false;
    }
    if (execute != null && !execute.isCacheable()) {
      return false;
    }
    return true;
  }
}
/* JavaCC - OriginalChecksum=f41480f6734998f6eac27242db146d09 (do not edit this line) */
